proc(1) = hacnw(x,u,m);

local z,k,T,S,zz,j;

/* x is the (Txk) matrix of observations and u are ols residuals */


/* Newey-West HAC covariance matrix as in West and Newey, NBER TWP#144, p.4 */


              /* z is a (k*T) matrix, where                             */
z = (u*~x)';  /*each column of z is z(t)=x(t)*u(t), where z(t) is (k*1) */
k=cols(x);
T=rows(x);
S=zeros(k,k);
zz=zeros(k,k);

S=z*z';   /* generating omega_0 */

j=1;
do while j <= m;
        zz= z[.,j+1:T]*z[.,1:T-j]';  /*NOTICE below that we save S/T */
        S=S+(1-(j/(m+1)))*(zz+zz');
j=j+1;
endo;

retp(S/T);

endp;
